<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:c="http://java.sun.com/jsp/jstl/core"
                template="/WEB-INF/templates/LoggedTemplate.xhtml">

    <ui:define name="pageTitleText">Editar Concepto</ui:define>

    <ui:define name="contentPart">

        <style>

            #botones{

                position: relative;
                bottom: 500px;
            }

        </style>
        <script>

            function resetSelects() {

                var v = document.getElementById("frmEditConcepto:ctes_input");
                v.options[0].selected = true;
                var v2 = document.getElementById("frmEditConcepto:funcYVar_input");
                v2.options[0].selected = true;
                var v3 = document.getElementById("frmEditConcepto:operadores_input");
                v3.options[0].selected = true;


            }
            function selectAll() {

                document.getElementById('frmEditConcepto:periodos:0').checked = true;
                document.getElementById('frmEditConcepto:periodos:1').checked = true;
                document.getElementById('frmEditConcepto:periodos:2').checked = true;
                document.getElementById('frmEditConcepto:periodos:3').checked = true;
                document.getElementById('frmEditConcepto:periodos:4').checked = true;
                document.getElementById('frmEditConcepto:periodos:5').checked = true;
                document.getElementById('frmEditConcepto:periodos:6').checked = true;
                document.getElementById('frmEditConcepto:periodos:7').checked = true;
                document.getElementById('frmEditConcepto:periodos:8').checked = true;
                document.getElementById('frmEditConcepto:periodos:9').checked = true;
                document.getElementById('frmEditConcepto:periodos:10').checked = true;
                document.getElementById('frmEditConcepto:periodos:11').checked = true;
                document.getElementById('frmEditConcepto:periodos:12').checked = true;
                document.getElementById('frmEditConcepto:periodos:13').checked = true;
                document.getElementById('frmEditConcepto:periodos:14').checked = true;
                document.getElementById('frmEditConcepto:periodos:15').checked = true;
                document.getElementById('frmEditConcepto:periodos:16').checked = true;
                document.getElementById('frmEditConcepto:periodos:17').checked = true;
                document.getElementById('frmEditConcepto:periodos:18').checked = true;
                document.getElementById('frmEditConcepto:periodos:19').checked = true;
                document.getElementById('frmEditConcepto:periodos:20').checked = true;
                document.getElementById('frmEditConcepto:periodos:21').checked = true;
                document.getElementById('frmEditConcepto:periodos:22').checked = true;
                document.getElementById('frmEditConcepto:periodos:23').checked = true;

            }
            ;
            function unSelectAll() {

                document.getElementById('frmEditConcepto:periodos:0').checked = false;
                document.getElementById('frmEditConcepto:periodos:1').checked = false;
                document.getElementById('frmEditConcepto:periodos:2').checked = false;
                document.getElementById('frmEditConcepto:periodos:3').checked = false;
                document.getElementById('frmEditConcepto:periodos:4').checked = false;
                document.getElementById('frmEditConcepto:periodos:5').checked = false;
                document.getElementById('frmEditConcepto:periodos:6').checked = false;
                document.getElementById('frmEditConcepto:periodos:7').checked = false;
                document.getElementById('frmEditConcepto:periodos:8').checked = false;
                document.getElementById('frmEditConcepto:periodos:9').checked = false;
                document.getElementById('frmEditConcepto:periodos:10').checked = false;
                document.getElementById('frmEditConcepto:periodos:11').checked = false;
                document.getElementById('frmEditConcepto:periodos:12').checked = false;
                document.getElementById('frmEditConcepto:periodos:13').checked = false;
                document.getElementById('frmEditConcepto:periodos:14').checked = false;
                document.getElementById('frmEditConcepto:periodos:15').checked = false;
                document.getElementById('frmEditConcepto:periodos:16').checked = false;
                document.getElementById('frmEditConcepto:periodos:17').checked = false;
                document.getElementById('frmEditConcepto:periodos:18').checked = false;
                document.getElementById('frmEditConcepto:periodos:19').checked = false;
                document.getElementById('frmEditConcepto:periodos:20').checked = false;
                document.getElementById('frmEditConcepto:periodos:21').checked = false;
                document.getElementById('frmEditConcepto:periodos:22').checked = false;
                document.getElementById('frmEditConcepto:periodos:23').checked = false;

            }
            ;

        </script>
        
            <h:form id="frmEditConcepto">  
            
                <p:growl id="confirmAddGrowl" 
                     showDetail="true" 
                     sticky="false"
                     for="confirmAddGrowl"/>                
                
                <h:outputText 
                    value="Nómina -> Configuración -> Conceptos -> Editar concepto" 
                    style="font-weight: bold"/>
                
                <table id="tblformEditConceptos">
                    <tr id="rnAConcepto">
                        <th>
                            <p:panel 
                                header="Características Generales" 
                                style="width: 1000px; height: 500px">
                                
                                <h:panelGrid columns="2">
                                    <h:panelGrid 
                                        columns="3" 
                                        cellspacing="5">
                                        
                                        <h:outputLabel 
                                            for="clave" 
                                            value="Clave Concepto*">                                                
                                        </h:outputLabel>         
                                        
                                        <h:inputText 
                                            id="clave" 
                                            maxlength="5" 
                                            size="5" 
                                            onkeyup="toUpperCase(event,this)" 
                                            disabled="true" 
                                            style="width: 250px" 
                                            required="true" 
                                            requiredMessage="Favor de agregar una clave al concepto."
                                            value="#{conceptoEditMB.conceptoEdit.claveConcepto}"/>
                                        
                                        <p:watermark 
                                            for="clave" 
                                            value="Clave Concepto" 
                                            id="ph1" />

                                        <h:outputLabel 
                                            for="nombre" 
                                            value="Nombre del Concepto*">                                                
                                        </h:outputLabel>         
                                        
                                        <h:inputText 
                                            id="nombre"  
                                            size="30"  
                                            value="#{conceptoEditMB.conceptoEdit.nombreConcepto}" 
                                            required="true" 
                                            onkeyup="toUpperCase(event,this)"
                                            style="width: 250px" 
                                            requiredMessage="Favor de agregar un nombre al concepto." 
                                            maxlength="100">
                                        </h:inputText>
                                        
                                        <p:watermark 
                                            for="nombre" 
                                            value="Nombre" 
                                            id="ph2" />
                                        
                                        <h:outputLabel 
                                            for="esConcepto" 
                                            value="Es concepto para Nómina*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="esConcepto" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.concepto}" 
                                            style="width: 250px" 
                                            requiredMessage="Es concepto requerido">
                                            
                                            <f:selectItem 
                                                itemValue="S" 
                                                itemLabel="SI" />
                                            
                                            <f:selectItem 
                                                itemValue="N" 
                                                itemLabel="NO" />
                                        </p:selectOneMenu> 
                                        
                                        <br/>
                                                                      
                                        <h:outputLabel 
                                            for="tipoNomina" 
                                            value="Tipo de Nómina*">                                                
                                        </h:outputLabel> 
                                        
                                        <p:selectOneMenu 
                                            id="tipoNomina" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomnCatTipoNomina}"  
                                            required="true" 
                                            style="width: 250px" 
                                            autoWidth="false"
                                            requiredMessage="El tipo de nómina es requerido" 
                                            converter="entityConverter">
                                            
                                            <f:selectItem   
                                                itemValue="#{null}"
                                                itemLabel="Elegir el tipo de nómina"
                                                noSelectionOption="true" 
                                                itemDisabled="true" />
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.tiposNomina}" 
                                                var="tipoNom" 
                                                itemLabel="#{tipoNom.strTipoNomina}" 
                                                itemValue="#{tipoNom}" />
                                        </p:selectOneMenu>                                        

                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="tipoCalculo" 
                                            value="Tipo Cálculo*">                                                
                                        </h:outputLabel> 
                                        
                                        <p:selectOneMenu 
                                            filter="true" 
                                            id="tipoCalculo" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomTipoCalculo}" 
                                            filterMatchMode="contains" 
                                            caseSensitive="false" 
                                            converter="entityConverter" 
                                            style="width: 250px" 
                                            requiredMessage="El tipo de cálculo es requerido">
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.tiposCalculo}" 
                                                var="tipoc" 
                                                itemLabel="#{tipoc.tipoCalculo}" 
                                                itemValue="#{tipoc}" />
                                            
                                            <p:ajax event="valueChange" 
                                                    process="@this"
                                                    listener="#{conceptoEditMB.selTipoCalculo}" 
                                                    update="frmEditConcepto"></p:ajax>
                                        </p:selectOneMenu> 
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="tipoClasificador" 
                                            value="Tipo de Clasificador*">                                                
                                        </h:outputLabel> 
                                        
                                        <p:selectOneMenu 
                                            id="tipoClasificador" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomnCatClasificadoresCon}"  required="true" 
                                            style="width: 250px" 
                                            requiredMessage="El tipo de clasificador es requerido" 
                                            converter="entityConverter">
                                            
                                            <f:selectItem   
                                                itemValue="#{null}"
                                                itemLabel="Elegir el tipo de clasificador"
                                                noSelectionOption="true" 
                                                itemDisabled="true" />
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.tiposClasificadoresCon}" 
                                                var="clasificador" 
                                                itemLabel="#{clasificador.strDescripcionConcepto}" 
                                                itemValue="#{clasificador}" />
                                        </p:selectOneMenu>                                        
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="tipoConcepto" 
                                            value="Tipo Concepto*">                                                
                                        </h:outputLabel> 
                                        
                                        <p:selectOneMenu 
                                            id="tipoConcepto" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomTipoConcepto}"  
                                            required="true" 
                                            style="width: 250px" 
                                            requiredMessage="El tipo de concepto es requerido" 
                                            converter="entityConverter">
                                            
                                            <f:selectItem   
                                                itemValue="#{null}"
                                                itemLabel="Elegir tipo de concepto"
                                                noSelectionOption="true" 
                                                itemDisabled="true" />
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.tiposConceptos}" 
                                                var="tipo" 
                                                itemLabel="#{tipo.tipoConcepto}" 
                                                itemValue="#{tipo}" />
                                            
                                            <p:ajax 
                                                event="valueChange" 
                                                listener="#{conceptoEditMB.onTipoConceptoSelect()}" 
                                                update="pgGravadoExcento  cuentaSAT"> </p:ajax>
                                        </p:selectOneMenu>
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="frecuenciaPago" 
                                            value="Frecuencia de Pago*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="frecuenciaPago" 
                                            filter="true" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomnCatFrecuenciaPagoTO}"  
                                            filterMatchMode="contains" 
                                            caseSensitive="false" 
                                            style="width: 250px" 
                                            panelStyle="width:100px" 
                                            requiredMessage="La frecuencia de pago es requerido" 
                                            converter="entityConverter">
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.tiposFrecuenciaPago}" 
                                                var="frecPago" 
                                                itemLabel="#{frecPago.frecuenciaPago}" 
                                                itemValue="#{frecPago}" />
                                        </p:selectOneMenu>                                                                                 
                                    </h:panelGrid>

                                    <h:panelGrid 
                                        columns="3" 
                                        cellpadding="5"> 
                                        
                                        <h:outputLabel 
                                            for="cuentaContable" 
                                            value="Cuenta Contable*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="cuentaContable" 
                                            filter="true" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomnCatCuentasContablesTO}"  
                                            filterMatchMode="contains" 
                                            caseSensitive="false" 
                                            style="width: 250px" 
                                            panelStyle="width:100px" 
                                            requiredMessage="La cuenta contable es requerida" 
                                            converter="entityConverter"
                                            autoWidth="false">
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.cuentasContablesLstView}" 
                                                var="cContable" 
                                                itemLabel="#{cContable.cuentaContable}" 
                                                itemValue="#{cContable}" />
                                        </p:selectOneMenu>                                        
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            value="Fundamento Legal" 
                                            for="articulo">                                                
                                        </h:outputLabel>
                                        
                                        <h:inputText 
                                            id="funLegal"  
                                            size="20" 
                                            value="#{conceptoEditMB.conceptoEdit.articulo}"
                                            style="width: 250px" 
                                            onkeyup="toUpperCase(event,this)" 
                                            maxlength="20">
                                        </h:inputText>
                                        
                                        <p:watermark 
                                            for="funLegal" 
                                            value="Artículo" 
                                            id="phFL" />
                                        
                                        <h:outputLabel 
                                            for="Partida" 
                                            value="Partida*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="Partida" 
                                            filter="true" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomPartidasPresup}"  
                                            filterMatchMode="contains" 
                                            caseSensitive="false" 
                                            style="width: 250px" 
                                            requiredMessage="La partida es requerida" 
                                            converter="entityConverter">
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.tipopartidas}" 
                                                var="partida" 
                                                itemLabel="#{partida.clavePresupuestal}" 
                                                itemValue="#{partida}" />
                                        </p:selectOneMenu> 
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="estatus" 
                                            value="Estatus*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="estatus" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.estatus}" 
                                            style="width: 250px" 
                                            requiredMessage="El estatus es requerido">
                                            
                                            <f:selectItem 
                                                itemValue="A" 
                                                itemLabel="Activo" />
                                            
                                            <f:selectItem 
                                                itemValue="I" 
                                                itemLabel="Inactivo" />
                                        </p:selectOneMenu> 
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="aplicaISN" 
                                            value="Aplica ISN*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="aplicaISN" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.aplicaISN}" 
                                            style="width: 250px" 
                                            requiredMessage="Aplica ISN es requerido">
                                            
                                            <f:selectItem 
                                                itemValue="S" 
                                                itemLabel="SI" />
                                            
                                            <f:selectItem 
                                                itemValue="N" 
                                                itemLabel="NO" />
                                        </p:selectOneMenu> 
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="aplicaRetroactividad" 
                                            value="Aplica Retroactividad*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="aplicaRetroactividad" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.aplicaRetroactividad}" 
                                            style="width: 250px" 
                                            requiredMessage="Aplica retroactividad es requerido">
                                            
                                            <f:selectItem 
                                                itemValue="S" 
                                                itemLabel="SI" />
                                            
                                            <f:selectItem 
                                                itemValue="N" 
                                                itemLabel="NO" />
                                        </p:selectOneMenu>
                                        
                                        <br/>
                                        
                                        <h:outputLabel 
                                            for="cuentaSAT" 
                                            value="Concepto SAT*">                                                
                                        </h:outputLabel>
                                        
                                        <p:selectOneMenu 
                                            id="cuentaSAT" 
                                            filter="true" 
                                            required="true" 
                                            value="#{conceptoEditMB.conceptoEdit.rhNomnCatConceptosSatTO}"  
                                            filterMatchMode="contains" 
                                            caseSensitive="false" 
                                            style="width: 250px" 
                                            panelStyle="width:100px" 
                                            requiredMessage="El concepto SAT es requerido" 
                                            converter="entityConverter"
                                            autoWidth="false">
                                            
                                            <f:selectItems 
                                                value="#{conceptoEditMB.conceptosSATView}" 
                                                var="cSAT" 
                                                itemLabel="#{cSAT.conceptoSATVista}" 
                                                itemValue="#{cSAT}" />
                                        </p:selectOneMenu>                                        
                                    </h:panelGrid> 
                                </h:panelGrid>

                                <h:panelGrid 
                                    id="pgGravadoExcento" 
                                    columns="2" 
                                    cellspacing="0">  
                                    
                                    <h:panelGrid 
                                        columns="2" 
                                        style="margin-bottom:10px" 
                                        cellpadding="5" 
                                        rendered="#{conceptoEditMB.renderGravado}">
                                        
                                        <p:selectOneRadio 
                                            id="gravado" 
                                            value="#{conceptoEditMB.conceptoEdit.gravado}">
                                            
                                            <f:selectItem 
                                                itemLabel="Gravado" 
                                                itemValue="G" />
                                            
                                            <f:selectItem 
                                                itemLabel="Exento" 
                                                itemValue="E" />
                                            
                                            <p:ajax 
                                                event="valueChange" 
                                                listener="#{conceptoEditMB.onGravadoSelect}" 
                                                update="pgGravadoExcento">  
                                            </p:ajax>
                                        </p:selectOneRadio>
                                    </h:panelGrid>
                                    
                                    <h:panelGrid 
                                        id="pgTopeExencion" 
                                        columns="2" 
                                        style="margin-bottom:10px; 
                                        position: relative; 
                                        left: 295px;" 
                                        cellpadding="5" 
                                        rendered="#{conceptoEditMB.renderTope}"  >
                                        
                                        <h:outputLabel value="Tope de exención" />
                                        
                                        <br/>
                                        
                                        <p:selectOneRadio 
                                            id="topeEx" 
                                            value="#{conceptoEditMB.conceptoEdit.topeExencion}">
                                            
                                            <f:selectItem 
                                                itemLabel="Días" 
                                                itemValue="D" />
                                            
                                            <f:selectItem 
                                                itemLabel="Porcentaje" 
                                                itemValue="P" />
                                            
                                            <f:selectItem 
                                                itemLabel="No aplica" 
                                                itemValue="N" />
                                            
                                            <p:ajax 
                                                event="valueChange" 
                                                update="pgTopeExencion">  
                                            </p:ajax>
                                        </p:selectOneRadio>
                                        
                                        <c:if test="#{conceptoEditMB.conceptoEdit.topeExencion=='D'}" >
                                            <p:inputNumber
                                                id="topeExValueD" 
                                                rendered="true" 
                                                size="10" 
                                                minValue="0"
                                                maxValue="999" 
                                                value="#{conceptoEditMB.conceptoEdit.exencionDias}"/>
                                           
                                        </c:if>
                                        
                                        <c:if test="#{conceptoEditMB.conceptoEdit.topeExencion=='P'}" >
                                            <p:inputNumber
                                                id="topeExValueD" 
                                                rendered="true" 
                                                size="10" 
                                                minValue="0.00"
                                                maxValue="100.00" 
                                                value="#{conceptoEditMB.conceptoEdit.exencionPorcentaje}"/>
                                           
                                        </c:if>
                                    </h:panelGrid>           
                                </h:panelGrid>
                            </p:panel>
                        </th>
                        
                        <th>
                            <p:panel 
                                header="Quincenas en que Aplica*" 
                                style="width: 300px; height: 500px">
                                
                                <h:panelGrid 
                                    columns="1" 
                                    cellspacing="11" 
                                    rendered="#{conceptoEditMB.renderQuicnenas}">
                                    
                                    <p:selectManyCheckbox 
                                        value="#{conceptoEditMB.quincenasDelConcepto}" 
                                        id="periodos" 
                                        layout="grid" 
                                        columns="4" 
                                        widgetVar="periodosClient">
                                            
                                        <f:selectItems 
                                            value="#{conceptoEditMB.quincenasList}" 
                                            var="periodo" >
                                        </f:selectItems>
                                    </p:selectManyCheckbox>                                    
                                    
                                    <p:commandButton 
                                        value="Seleccionar Todas" 
                                        update=":frmEditConcepto:periodos" 
                                        style="width: 170px" 
                                        onclick="selectAll()"
                                        ignoreAutoUpdate="true">
                                    </p:commandButton>
                                    
                                    <p:commandButton 
                                        value="Quitar Todas" 
                                        update=":frmEditConcepto:periodos" 
                                        style="width: 170px" 
                                        onclick="unSelectAll()"
                                        ignoreAutoUpdate="true">                                            
                                    </p:commandButton>
                                </h:panelGrid>                                
                            </p:panel>
                        </th>
                    </tr>

                    <tr id="rnBConcepto">
                        <th id="colBrnAConcepto">
                            <p:panel 
                                id="pnlFormulaAdd" 
                                header="Definición de la Fórmula" 
                                style="width: 1000px; height: 345px" 
                                rendered="#{conceptoEditMB.aplicaFormula}">

                                <h:panelGrid 
                                    columns="1" 
                                    cellspacing="10" 
                                    style="position: relative; left:8%;">
                                    
                                    <p:outputLabel 
                                        value="Fórmula" 
                                        for="formula">                                            
                                    </p:outputLabel>
                                    
                                    <h:inputText 
                                        id="formula" 
                                        value="#{conceptoEditMB.formula}" 
                                        style=" width: 820px; height: 65px" 
                                        readonly="true" 
                                        required="true" 
                                        requiredMessage="Fórmula es requerida">
                                    </h:inputText>                                    
                                </h:panelGrid>
                                
                                <br/>
                                
                                <p:outputLabel value="Seleccione las siguientes opciones para generar la fómula:" />
                                
                                <h:panelGrid 
                                    columns="3" 
                                    cellspacing="10" 
                                    style="position:relative; 
                                    left:12%">
                                    
                                    <p:selectOneMenu 
                                        id="ctes" 
                                        converter="entityConverter"  
                                        filter="true" 
                                        style="width:200px;" 
                                        filterMatchMode="contains" 
                                        caseSensitive="false" 
                                        value="#{conceptoEditMB.constanteSelected}"
                                        autoWidth="false" >
                                        
                                        <f:selectItem   
                                            itemValue="#{null}"
                                            itemLabel="Constantes"
                                            noSelectionOption="true" 
                                            itemDisabled="true"  />
                                        
                                        <f:selectItems 
                                            value="#{conceptoEditMB.constantes}" 
                                            var="ctes" 
                                            itemLabel="#{ctes.nombreArgumento}"  
                                            itemValue="#{ctes}"/>
                                        
                                        <p:ajax 
                                            event="valueChange" 
                                            listener="#{conceptoEditMB.onConstanteSelect}"  
                                            update=":frmEditConcepto:formula,ctes testConcepto" 
                                            oncomplete="resetSelects()">
                                        </p:ajax>
                                        
                                        <p:ajax 
                                            event="valueChange" 
                                            listener="#{probarConceptoMB.limpiarTest}" 
                                            update="testConcepto"/>
                                    </p:selectOneMenu> 

                                    <p:selectOneMenu 
                                        id="funcYVar" 
                                        converter="entityConverter" 
                                        value="#{conceptoEditMB.varSelected}" 
                                        filter="true"
                                        style="width:200px;" 
                                        filterMatchMode="contains" 
                                        caseSensitive="false" 
                                        autoWidth="false">
                                        
                                        <f:selectItem   
                                            itemValue="#{null}"
                                            itemLabel="Funciones"
                                            noSelectionOption="true" 
                                            itemDisabled="true"  />
                                        
                                        <f:selectItems 
                                            value="#{conceptoEditMB.funcionesYVariables}" 
                                            var="fyv" 
                                            itemLabel="#{fyv.nombreArgumento}"  
                                            itemValue="#{fyv}"/>

                                        <p:ajax 
                                            event="valueChange" 
                                            listener="#{conceptoEditMB.onVarSelect}" 
                                            oncomplete="resetSelects()" 
                                            update=":frmEditConcepto:formula testConcepto">  </p:ajax>
                                        
                                        <p:ajax 
                                            event="valueChange" 
                                            listener="#{probarConceptoMB.limpiarTest}" 
                                            update="testConcepto"/>
                                    </p:selectOneMenu> 

                                    <p:selectOneMenu 
                                        id="operadores"
                                        style="width:200px;" 
                                        autoWidth="false"
                                        converter="entityConverter"  
                                        value="#{conceptoEditMB.operadorSelected}" 
                                        filter="true" >
                                        
                                        <f:selectItem   
                                            itemValue="#{null}"
                                            itemLabel="Operadores"
                                            noSelectionOption="true" 
                                            itemDisabled="true"  />
                                        
                                        <f:selectItems 
                                            value="#{conceptoEditMB.operadores}" 
                                            var="op" 
                                            itemLabel="#{op}"  
                                            itemValue="#{op}"/>

                                        <p:ajax 
                                            event="valueChange" 
                                            listener="#{conceptoEditMB.onOperadprSelect}" 
                                            oncomplete="resetSelects()" 
                                            update=":frmEditConcepto:formula testConcepto"  >  
                                        </p:ajax>
                                        
                                        <p:ajax 
                                            event="valueChange" 
                                            listener="#{probarConceptoMB.limpiarTest}" 
                                            update="testConcepto"/>
                                    </p:selectOneMenu> 
                                </h:panelGrid>                                    
                                
                                <br/>                                    
                                
                                <p:commandButton 
                                    value="Limpiar Fórmula" 
                                    actionListener="#{conceptoEditMB.vaciarFormula}" 
                                    action="#{probarConceptoMB.limpiarTest}" 
                                    style="width: 345px" 
                                    update=":frmEditConcepto:formula testConcepto" >
                                </p:commandButton>                                
                            </p:panel>
                            
                            <br/>
                            
                            <p:commandButton
                                value="Actualizar"
                                update="confirmAddGrowl"
                                oncomplete="redirect(xhr, status, args, 'ListConceptos.jsf');"
                                actionListener="#{conceptoEditMB.guardarConcepto()}" />         
                            
                            <p:commandButton
                                value="Cerrar"
                                onclick="location = 'ListConceptos.jsf';"/>                            
                        </th>
                        
                        <th>
                            <p:panel 
                                id="testConcepto" 
                                header="Prueba de la Fórmula" 
                                style="width: 300px; 
                                height: 400px" 
                                rendered="#{conceptoEditMB.aplicaFormula}">                                
                                
                                <h:panelGrid  columns="2">
                                    <p:commandButton 
                                        value="1.Cargar los parámetros para realizar la prueba" 
                                        update=":frmEditConcepto:" 
                                        actionListener="#{probarConceptoMB.cargaParametrosPrueba(conceptoEditMB.argumentosDeFormula, conceptoEditMB.formula)}">
                                    </p:commandButton>
                                </h:panelGrid>
                                
                                <br/>
                                
                                <p:outputLabel value="2.Captura de valores para realizar la prueba: " />
                                
                                <h:panelGrid 
                                    columns="2" 
                                    rendered="#{probarConceptoMB.renderPruebaValor}">                                    
                                    
                                    <ui:repeat 
                                        value="#{probarConceptoMB.campos}" 
                                        var="item" >
                                        
                                        <p:outputLabel 
                                            value="#{item.nombre}" 
                                            for="campo">
                                        </p:outputLabel>
                                        
                                        <p:inputNumber 
                                            id="campo" 
                                            value="#{item.valor}" 
                                            style="width: 100px"/>
                                        
                                        <br/>
                                    </ui:repeat>
                                </h:panelGrid>
                                
                                <h:panelGrid 
                                    columns="3" 
                                    rendered="#{probarConceptoMB.renderPruebaId}">
                                    
                                    <ui:repeat 
                                        value="#{conceptoEditMB.conceptoEdit.listaParametrosTO}" 
                                        var="itemParam" >
                                        
                                        <p:inputText  
                                            id="campoParam" 
                                            value="#{itemParam.valor}" 
                                            title="#{itemParam.msgAyuda}"/>
                                        
                                        <br/>
                                        
                                        <p:watermark 
                                            for="campoParam" 
                                            value="#{itemParam.parametro}"  />
                                    </ui:repeat>                                    
                                </h:panelGrid>
                                
                                <h:panelGrid columns="2" >
                                    <p:commandButton 
                                        value="3.Probar" 
                                        update=":frmEditConcepto:" 
                                        actionListener="#{probarConceptoMB.test(conceptoEditMB.conceptoEdit,conceptoEditMB.formula)}" 
                                        action="#{conceptoEditMB.validaTest(probarConceptoMB.formulaSustituida)}" >
                                    </p:commandButton>
                                    
                                    <p:commandButton 
                                        value="4.Limpiar" 
                                        update=":frmEditConcepto:" 
                                        actionListener="#{probarConceptoMB.vaciarCamposTest}">
                                    </p:commandButton>                                    
                                </h:panelGrid>
                                
                                <h:panelGrid 
                                    columns="1" 
                                    cellpadding="2">
                                    
                                    <h:outputLabel value="Fórmula con Valores: " />
                                    
                                    <h:outputLabel 
                                        id="exprSust" 
                                        value="#{probarConceptoMB.formulaSustituida}">
                                    </h:outputLabel>
                                    
                                    <h:outputLabel value="Importe:" />
                                    
                                    <h:outputLabel 
                                        id="restest" 
                                        value="#{probarConceptoMB.resultado}">
                                    </h:outputLabel>
                                </h:panelGrid>                                
                            </p:panel>
                        </th>                        
                    </tr>
                </table>

                <br/>      
            
            </h:form>
    </ui:define>
</ui:composition>
